## Class Ecran

- java.lang.Object
- - Ecran

-     public class Ecran
      extends java.lang.Object

  Fonctions d'affichage dans la console d'exécution.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Ecran()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `afficher(java.lang.Object... s)` Affichage dans la console d'exécution.
    `static void` | `afficherln(java.lang.Object... s)` Affichage dans la console d'exécution suivi d'un saut de ligne.
    `static void` | `formater(java.lang.String format, java.lang.Object... s)` Affichage dans la console d'exécution d'une liste de paramètres individuellement formatés.
    `static void` | `sautDeLigne()` Saut de ligne dans la console d'exécution.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Ecran

          public Ecran()

  - ### Method Detail

    - #### afficher

          public static void afficher(java.lang.Object... s)

      Affichage dans la console d'exécution.

      Indication entre parenthèses de la liste des 0, 1 ou plusieurs parametres à afficher:
      - variables,
      - constantes,
      - expressions,
      - ...

      Parameters:
        `s` - La liste des parametres a afficher.

    - #### afficherln

          public static void afficherln(java.lang.Object... s)

      Affichage dans la console d'exécution suivi d'un saut de ligne.

      Indication entre parenthèses de la liste des 0, 1 ou plusieurs parametres à afficher:
      - variables,
      - constantes,
      - expressions,
      - ...

      Parameters:
        `s` - La liste des parametres a afficher.

    - #### sautDeLigne

          public static void sautDeLigne()

      Saut de ligne dans la console d'exécution.

    - #### formater

          public static void formater(java.lang.String format,
                                      java.lang.Object... s)

      Affichage dans la console d'exécution d'une liste de paramètres individuellement formatés.
      L'affichage est spécifié au moyen d'une String qui peut contenir du texte fixe et 0, 1 ou plus descripteurs d'affichage.
      A chaque descripteur doit correspondre un paramètre compatible dans la liste des paramètres d'appel.
      Exemple:
      Ecran.formater("Resultat : %3d %6.2f",a,b);
      affiche la chaine "Resultat : ", suivie de la valeur du paramètre a convertie en entier formatée sur 3 caractères de large au minimum (cadrage à droite éventuellement complémenté par autant d'espaces que nécessaire), suivie d'un espace, suivie de la valeur du paramètre b convertie en réel flottant formatée sur 6 caractères de large au minimum avec 2 chiffres après la virgule (cadrage à droite éventuellement complémenté par autant d'espaces que nécessaire).
      Deux descripteurs apparaissent dans la chaine format: %3d et %6.2f. Deux paramètres doivent être passés à la fonction en plus de la chaine format. Il s'agit de a et de b.
      Chaque descripteur d'affichage doit respecter la syntaxe suivante: %[index_parametre$][drapeaux][largeur][.precision]conversion.
      - index_parametre (optionnel) est un entier qui indique la position de l'argument dans la liste des paramètres. Le premier paramètre est referencé par "1$", le second par "2$", ...
      - drapeaux (optionnel) est un ensemble de charactères qui modifie l'affichage. L'ensemble des drapeaux valides dépend de conversion (voir + loin).
      - largeur (optionnel) est un entier non négatif indiquant le nombre minimum de caractères devant être affichés.
      - precision (optionnel) est un entier non négatif habituellement utilisé pour contrôler/restreindre le nombre de charactéres affichés. Le comportement spécifique de precision dépend de conversion (voir + loin).
      - conversion (requis) est un charactère indiquant selon quelle conversion (vers quel type) le paramètre doit être converti et formaté. L'ensemble des conversions valides pour un paramètre donné depend du type de donnée du paramètre.
      La table suivante liste de manière non exhaustive les valeurs possibles de conversion, le type de paramètre sur lequel la conversion est possible, et, le résultat affiché.
      - 'b', 'B' : Tous types : Si le paramètre est boolean, l'affichage est "true" ou "false" suivant sa valeur. Dans les autres cas, l'affichage est "true".
      - 's', 'S' : Tous types : L'affichage est réalisé par conversion en une chaine de caractères.
      - 'c', 'C' : char : L'affichage du caractère est réalisé.
      - 'd' : byte, short, int, long : L'affichage de l'entier est réalisé en valeur décimale (base 10).
      - 'o' : byte, short, int, long : L'affichage de l'entier est réalisé en valeur octale (base 8).
      - 'x', 'X' : byte, short, int, long : L'affichage de l'entier est réalisé en valeur hexadécimale (base 16).
      - 'e', 'E' : float, double : L'affichage du réel est réalisé sous forme mantisse exposant avec precision chiffres après la virgule sur la mantisse quitte à dépasser largeur.
      - 'f' : float, double : L'affichage du réel est réalisé sous forme partie entière.partie décimale avec precision chiffres après la virgule quitte à dépasser largeur.
      La table suivante liste de manière non exhaustive les valeurs possibles pour les drapeaux.
      - '-' : Tous types : L'affichage est cadré à gauche (cadrage à droite si '-' non spécifié, pas de cadrage au centre).
      - '+' : Types numériques : L'affichage inclut toujours un signe (+ pour les nombres positifs, - pour les nombres négatifs).
      - ' ' : Types numériques : L'affichage inclut toujours un espace à gauche.
      - '0' : Types numériques : L'affichage est complété par des zéros à gauche au lieu d'espaces.
      La valeur largeur definit le nombre de caractères utilisés au minimum pour l'affichage. Si la valeur à afficher necessite moins de caractères que spécifié, des caractères supplémentaires sont ajoutés selon le format défini. Si ce n'est pas le cas, la valeur est complétement affichée en utilisant plus de caractères que ne le spécifie largeur.
      La valeur précision définit le nombre de chiffres de précision utilisés pour les nombres réels.
      L'inclusion d'un \n dans la chaine format entraine un saut à la ligne.
      Exemple 1:
      `int a = 5;`
      `double d = 3.14159;`
      `boolean b = true;`
      `char c = 'a';`
      `String s = "Test";`
      `Ecran.formater("%8d\n%8.2f\n%8b\n%8c\n%8s\n",a,d,b,c,s);`
      conduit aux affichages suivants où les items affichés sont cadrés à droite sur 8 caractères de large et le nombre réel est affiché avec deux chiffres après la virgule:
      `5`
      `3.14`
      `true`
      `a`
      `Test`
      Exemple 2:
      `int i = 1005;`
      `Ecran.formater("%8d\n%8o\n%8x\n%8b\n%8s\n%8c\n",i,i,i,i,i,i);`
      conduit aux affichages suivants où le nombre entier 1005 est affiché en base 10, en base 8 (octal), en base 16 (hexadécimal), après conversion en booléen, après conversion en chaine de caractères, après conversion en caractère (? car pas de caractère code ASCII 1005):
      `1005`
      `1755`
      `3ed`
      `true`
      `1005`
      `?`
      Exemple 3:
      `double d = 367.1415934574267;`
      `Ecran.formater("%8e\n%8f\n",d,d);`
      `Ecran.formater("%8.3e\n%8.3f\n",d,d);`
      `Ecran.formater("%20.12e\n%20.12f\n",d,d);`
      `Ecran.formater("%8b\n%8s\n",d,d);`
      conduit aux affichages suivants où un nombre réel est affiché en notation partie entière.partie décimale ou en notation mantisse exposant selon différents scénarii de largeur et de précision, et, après conversion en booléen et en chaine de caractères:
      `3.671416e+02`
      `367.141593`
      `3.671e+02`
      `367.142`
      `3.671415934574e+02`
      `367.141593457427`
      `true`
      `367.1415934574267`
      Exemple 4:
      `int i = 1005;`
      `Ecran.formater("%-8d\n%+8d\n% 8d\n%08d\n",i,i,i,i);`
      `Ecran.formater("%+08d\n",i);`
      `int j = -1005;`
      `Ecran.formater("%-8d\n%+8d\n% 8d\n%08d\n",j,j,j,j);`
      `Ecran.formater("%+08d\n",j);`
      conduit aux affichages suivants où les drapeaux '-', '+', ' ' et '0' montre le cadrage à gauche, l'ajout obligatoire du signe + pour les nombres positifs, l'ajout d'un espace à gauche et l'utilisation de '0' au lieu de ' ' pour la complémentation à gauche de façon à afficher le bon nombre de caractères pour atteindre la largeur spécifiée :
      `1005`
      `+1005`
      `1005`
      `00001005`
      `+0001005`
      `-1005`
      `-1005`
      `-1005`
      `-0001005`
      `-0001005`
      Parameters:
        `format` - La chaine de caratères décrivant le format d'affichage.
        `s` - La liste des paramètres à afficher.